package org.devcake.groovy.autoimports

import org.codehaus.groovy.control.CompilationUnit
import org.codehaus.groovy.ast.ImportNode
import org.codehaus.groovy.control.SourceUnit
import org.codehaus.groovy.control.CompilationFailedException
import org.codehaus.groovy.ast.ModuleNode

/**
 * User: Sergey Bondarenko
 * Date: 8/11/11
 */
class AutoImportsOperation extends CompilationUnit.SourceUnitOperation {
    AutoImportsGroovyClassLoader loader
    List<ImportNode> defaultImports = []
    List<ImportNode> starImports = []
    Map<String, ImportNode> staticStarImports = [:]
    Map<String, ImportNode> staticImports = [:]

    public void call(SourceUnit source) throws CompilationFailedException {
        ModuleNode module = source.getAST()
        defaultImports.each{ if (module.getImport(it.alias) == null && loader.classIsAvailable(it.type.name)) module.addImport(it.alias, it.type) }
        starImports.each{ module.addStarImport(it.packageName) }
        staticStarImports.each{ if (loader.classIsAvailable(it.value.type.name)) module.addStaticStarImport(it.key, it.value.type) }
        staticImports.each{ if (!module.staticImports.containsKey(it.key) && loader.classIsAvailable(it.value.type.name)) module.addStaticImport(it.value.type, it.key, it.key) }
    }
}